<!doctype html>
<html lang="en">

  <head>
    <meta charset="utf-8">

    <title>Intermediate HTML &amp; CSS — Catalyst</title>

    <meta name="author" content="Catalyst">

    <meta name="apple-mobile-web-app-capable" content="yes" />
    <meta name="apple-mobile-web-app-status-bar-style" content="black-translucent" />

    <meta name="viewport" content="width=device-width, initial-scale=1.0, maximum-scale=1.0, user-scalable=no">

    <link rel="stylesheet" href="css/reveal.css">
    <link rel="stylesheet" href="css/theme/catalyst.css" id="theme">

    <!-- For syntax highlighting -->
    <!-- <link rel="stylesheet" href="lib/css/zenburn.css"> -->
    <link rel="stylesheet" href="lib/css/catalyst-syntax.css">

    <!-- If the query includes 'print-pdf', include the PDF print sheet -->
    <script>
      if( window.location.search.match( /print-pdf/gi ) ) {
        var link = document.createElement( 'link' );
        link.rel = 'stylesheet';
        link.type = 'text/css';
        link.href = window.location.search.match( /print-pdf/gi ) ? 'css/print/pdf.css' : 'css/print/paper.css';
        document.getElementsByTagName( 'head' )[0].appendChild( link );
      }
    </script>

    <style>
      /* Add the ability to omit slides from the printed version (has to be after the print include)*/
      @media print {
        .reveal .slides section.no-print {
          display: none !important;
          visibility: hidden !important;
        }
      }
    </style>

    <!--[if lt IE 9]>
    <script src="lib/js/html5shiv.js"></script>
    <![endif]-->

    <!-- Please put any custom styles here -->
    <style>

    </style>
</head>

<body>

  <div class="reveal">

    <!-- Any section element inside of this container is displayed as a slide -->
    <div class="slides">
      <!-- Cover slide -->
      <section>
        <h3>Intermediate HTML &amp; CSS </h3>
        <aside class="notes">
          Mostly CSS! (This will only display in the notes window.)
        </aside>
      </section>

      <!-- Housekeeping -->
      <section>
        <h3>Housekeeping</h3>
        <ul>
          <li>Emergency</li>
          <li>Bathrooms</li>
          <li>Breaks</li>
          <li>Leave by a certain time?</li>
        </ul>
      </section>

      <!-- About -->
      <section>
        <h3>Hello!</h3>
        <p>A bit about me</p>
        <p class="fragment">You?</p>
      </section>

      <!-- Assumptions -->
      <section>
        <h3>Assumptions</h3>
        <p>Already have a solid understanding of basic CSS, including IDs, classes, and inheritance.</p>
        <!-- <p>Those that know basic CSS already but would like to be able to build on those skills to get an understanding of modern CSS and HTML development.</p> -->
      </section>

      <!-- Overview -->
      <section>
        <h3>Overview</h3>
        <ul class="small">
          <li>Semantic HTML</li>
          <li>Thinking about layout — block formatting contexts</li>
          <li>Stacking contexts</li>
          <li>Injecting content using ::before and ::after</li>
          <li>Advanced selectors</li>
          <li>Using a pre-processor to speed up development (SCSS)</li>
          <li>Structuring your CSS for maintainability</li>
          <li>Media queries</li>
          <li>Intro to CSS animations &amp; flexbox</li>
        </ul>
      </section>

      <!-- Section title — Contexts -->
      <section class="title-slide">
        <h2 class="orange">Semantic HTML</h2>
      </section>

      <!-- HTML — semantic -->
      <section>
        <h3>Semantic markup</h3>
        <p>Use &lt;nav&gt;, &lt;footer&gt;, and &lt;article&gt; etc. but only base your styling directly on those element selectors if you can <strong>be sure</strong> you’ll only use them for one purpose.</p>
        <p>For the most part, give them a more meaningful class name, and use that for your styling, e.g.</p>
        <pre><code class="hljs" data-trim contenteditable>
          &lt;nav class="main-nav"&gt;
        </code></pre>
      </section>

      <!-- HTML — semantic -->
      <section>
        <h3>Semantic HTML</h3>
        <ul>
          <li>&lt;button&gt; is better than #button or .button</li>
          <li>If you need to disable it, use <strong>disabled="true"</strong> and do your styling based using attribute selector
            <pre><code class="hljs" data-trim contenteditable>
              [disabled=true] { /* your styles — more on this later! */ }
            </code></pre>
          </li>
          <li>If you have to use something else, give it <strong>ARIA role="button"</strong>
          </li>
        </ul>
      </section>

      <!-- HTML — semantic — ARIA -->
      <section>
        <h3>ARIA</h3>
        <h4>Accessible Rich Internet Applications</h4>
        <p>Set of attributes that define ways to make web content and applications (especially those developed with JS) more accessible to people with disabilities.</p>
        <pre><code class="hljs" data-trim contenteditable>
          &lt;div id="main" role="main"&gt;
            &lt;p&gt;Main content text&lt;/p&gt;
          &lt;/div&gt;
        </code></pre>
        <p><a href="https://developer.mozilla.org/en-US/docs/Web/Accessibility/ARIA" target="_blank" rel="noopener noreferrer" style="text-decoration:underline;">ARIA</a> / <a href="https://developer.mozilla.org/en-US/docs/Web/Accessibility/ARIA/ARIA_Techniques" target="_blank" rel="noopener noreferrer" style="text-decoration:underline;">ARIA roles, states, and properties</a></p>
      </section>

      <!-- Section — formatting & stacking contexts -->
      <section class="title-slide banner-2">
        <h2 class="yellow">Formatting <br>&amp; stacking contexts</h2>
      </section>

      <!-- CSS overview — layout -->
      <section>
        <h3>Layout fundamentals</h3>
        <ul>
          <li>Static elements sit in the 'normal' flow of the page</li>
          <li>Vertical margins get smooshed together (between siblings, only if they are in the same block formatting context)</li>
          <li>Floats interact with each other until they get cleared</li>
        </ul>
      </section>

      <!-- CSS overview — block formatting -->
      <section>
        <h3>Block formatting contexts</h3>
        <p>&hellip;those layout fundamentals are true within a block formatting context.</p>
        <p>The &lt;html&gt; element creates a block formatting context, but there are other ways of creating them too:</p>
      </section>

      <!-- CSS overview — block formatting -->
      <section>
        <h3 style="display: none;">Creating block formatting contexts</h3>
        <div class="split">
          <ul>
            <li>display
              <ul>
                <li>inline-block</li>
                <li>table-cell</li>
                <li>table</li>
                <li>caption</li>
                <li>flex</li>
                <li>inline-flex</li>
              </ul>
            </li>
          </ul>
        </div>
        <div class="split">
          <ul>
            <li>position
              <ul>
                <li>absolute</li>
                <li>fixed</li>
              </ul>
            </li>
            <li>overflow
              <ul>
                <li>hidden</li>
                <li>scroll </li>
                <li>auto</li>
              </ul>
            </li>
          </ul>
        </div>
      </section>

      <!-- CSS overview — block formatting -->
      <section>
        <h3>Block formatting contexts</h3>
        <p><strong>Within each</strong> block formatting context:</p>
        <ul>
          <li>Floats interact with each other</li>
          <li>Vertical margins collapse</li>
        </ul>
        <p>We can use this fact to clear elements without having to have a clearing element or clearfix class.</p>
        <p><strong>Open html-css-example/example-1.html to see this in action.</strong></p>
      </section>

      <!-- CSS overview — stacking -->
      <section>
        <h3>Stacking contexts</h3>
        <ul>
          <li>If we have two elements on the page that overlap due to being positioned, the <strong>element further down the DOM</strong> is on top</li>
          <li>We can change the stacking order of elements by using the <strong>z-index</strong> property and giving a <strong>'position: relative'</strong> with no co-ordinates (or another non-static position)</li>
        </ul>
      </section>

      <!-- CSS overview — stacking -->
      <section>
        <h3>Stacking contexts</h3>
        <p>So to stack something on top we’d put on an even higher z-index?</p>
        <p>Not quite that simple&hellip; the nesting matters.</p>
      </section>

      <!-- CSS overview — stacking -->
      <section>
        <h3>Stacking contexts</h3>
        <ul>
          <li>A stacking context is created by applying one of these properties to the element:
            <ul>
              <li>z-index with position relative/absolute</li>
              <li>opacity (when less than 1)</li>
              <li>transform <a href="https://developer.mozilla.org/en-US/docs/Web/CSS/CSS_Positioning/Understanding_z_index/The_stacking_context" target="_blank" rel="noopener noreferrer">...and more</a></li>
            </ul>
          </li>
          <li>Each stacking context behaves like a group or folder which has its own position — the children of the element are 'nested' within it</li>
        </ul>
      </section>

      <!-- CSS overview — z-index -->
      <section>
        <h3><em>Please!</em></h3>
        <p>Don’t use 'z-index:10000' or something to that effect to make something 'just work'!</p>
        <p><strong>Open up html-css-examples/example-2.html to see it in action.</strong></p>
      </section>

      <!-- Section — selectors -->
      <section class="title-slide banner-2">
        <h2 class="blue">Advanced selectors</h2>
      </section>

      <!-- CSS overview — ::before & after -->
      <section>
        <h3>::before and ::after</h3>
        <p>These create a <strong>pseudo-element</strong> that is the first child of the selected element.</p>
        <p>There are some neat tricks you can do with this, e.g.
        </p>
        <pre><code class="hljs" data-trim contenteditable>
          a[href]::after {
            content: " (" attr(href) ")";
          }
        </code></pre>
        <pre><code class="hljs" data-trim contenteditable>
          .next::before {
            content: "\2794"; /* encoding for ➔ */
          }
        </code></pre>
      </section>

      <!-- CSS overview — ::before & after -->
      <section>
        <h3>::before and ::after</h3>
        <p><strong>Open html-css-examples example-3.html to view these</strong></p>
      </section>

      <!-- CSS overview — ::before & after -->
      <section>
        <h3>Why the double colons?!</h3>
        <p>:: is the newer format indented to distinguish a <br><strong>pseudo-element</strong> from a <strong>pseudo-class</strong>.</p>
        <pre><code class="hljs" data-trim contenteditable>
          ::before { /* CSS3 syntax */ }

          :before { /* CSS2 syntax */ }
        </code></pre>
        <p>CSS3 syntax also supports the (:) syntax. If you don't need IE 8 support, use the double colon.</p>
      </section>

      <!-- CSS — selectors -->
      <section>
        <h3>Advanced selectors</h3>
        <p><strong>Open example-4.html to view examples of these.</strong></p>
        <div style="text-align:left;">
          <pre><code class="hljs" data-trim contenteditable>
            /* Target everything (*) */
            * { margin: 0; }

            /* Immediate child (>) */
            div > ul { list-style: none; } /* ul directly nested in a div */

            /* Adjacent (+) */
            p + span { font-weight: bold; } /* span directly after a p */

            /* Sibling (~) */
            p ~ span { font-weight: bold; }
            /* any span after a p, which has the same parent */
          </code></pre>
        </div>
      </section>


      <!-- CSS selector game -->
      <section>
        <h3>Let’s have a play with some selectors 🍣</h3>
        <p><a href="http://flukeout.github.io/" target="_blank" rel="noopener noreferrer" style="text-decoration:underline;">flukeout.github.io</a></p>
      </section>


      <!-- Section — scss -->
      <section class="title-slide banner-4">
        <h2 class="orange">SCSS</h2>
      </section>

      <!-- SCSS -->
      <section>
        <h3>SCSS</h3>
        <h4>Syntactically Awesome Style Sheets</h4>
        <ul>
          <li>SCSS is a CSS preprocessor, a.k.a. SASS</li>
          <li>Disadvantages: compilation step!
            <ul>
              <li>Slows down testing of changes</li>
              <li>How do we deploy the compiled file</li>
              <li>How do we store the files in version control?</li>
            </ul>
          </li>
        </ul>
      </section>

      <!-- SCSS — advantages -->
      <section>
        <h3>SCSS — Advantages</h3>
        <ul>
          <li>Variables!</li>
          <li>Basic scripting and reusable components</li>
          <li>Better structure</li>
          <li>Nicer comments ( // instead of /* */ )</li>
          <li>Lots of tools we can leverage, e.g. Grunt</li>
        </ul>
      </section>

      <!-- SCSS — exercise -->
      <section>
        <h3>SCSS — Let’s do some</h3>
        <ul>
          <li>Open scss-example/index.html in a browser</li>
          <li>Open scss-example/scss/main.scss in an editor</li>
          <li>In a terminal:
            <ul>
              <li>do 'cd scss-example'</li>
              <li>and then do 'gulp watch'</li>
            </ul>
          </li>
        </ul>
      </section>

      <!-- SCSS — nesting -->
      <section>
        <h3>Nesting</h3>
        <pre><code class="hljs" data-trim contenteditable>
          header {
            padding: 10px;

            h2 {
              font-style: italic;
            }

            &:hover {
              background-color: lightsteelblue;
            }
          }
        </code></pre>
      </section>

      <!-- SCSS — nesting -->
      <section>
        <h3>Compiled CSS:</h3>
        <pre><code class="hljs" data-trim contenteditable>
          header {
            padding: 10px;
          }

          header h2 {
            font-style: italic;
          }

          header:hover {
            background-color: lightsteelblue;
          }
        </code></pre>
      </section>

      <!-- SCSS — vars -->
      <section>
        <h3>Variables</h3>
        <pre><code class="hljs" data-trim contenteditable>
          $brand-color: lightsteelblue;

          header {
            padding: 10px;

            h2 { font-style: italic; }

            &:hover {
              background-color: $brand-color;
            }
          }

          article {
            background-color: $brand-color;
          }
        </code></pre>
      </section>

      <!-- SCSS — media queries -->
      <section>
        <h3>Media queries</h3>
        <p>Useful for modifying values depending on a device&rsquo;s general type (e.g. screen or print)<br>or specific characteristics and parameters (e.g. screen resolution or <strong>browser viewport width</strong>).</p>
        <pre><code class="hljs" data-trim contenteditable>
          $breakpoint: "only screen and (min-width: 768px)";

          h2 {
            font-size: 20px;

            @media #{$breakpoint} {
              font-size: 28px;
            }
          }
        </code></pre>
      </section>

      <!-- SCSS — @import -->
      <section>
        <h3>Cleverer @import</h3>
        <p>Any file names that begin with an underscore will be imported into place during the compilation.</p>
        <p>The 'partial' .scss file won’t get converted to a .css file.</p>
      </section>

      <!-- SCSS — @extend -->
      <section>
        <h3>@extend</h3>
        <pre><code class="hljs" data-trim contenteditable>
          .error {
            border: 1px solid #f00;
            background-color: #fdd;
          }

          .serious-error {
            @extend .error;
            border-width: 3px;
          }
        </code></pre>
      </section>

      <!-- SCSS — @mixin -->
      <section>
        <h3>@mixin</h3>
        <pre><code class="hljs" data-trim contenteditable>
          @mixin large-text {
            font-size: 120%;
            font-weight: bold;
            color: #ff0000;
          }

          .highlighted-para {
            @include large-text;
            padding: 4px;
            margin-top: 10px;
          }
        </code></pre>
      </section>

      <!-- SCSS — @mixin -->
      <section>
        <h3>@mixin with arguments</h3>
        <pre><code class="hljs" data-trim contenteditable>
          @mixin fancy-border($color, $width: 1px) {
            border-color: $color;
            border-width: $width;
            border-style: dashed;
          }

          article {
            @include fancy-border(blue);
          }
        </code></pre>
      </section>

      <!-- SCSS — @mixin -->
      <section>
        <h3>@extend vs. @mixin</h3>
        <ul>
          <li>@extend usually produces better compiled CSS, so use that when you can</li>
          <li>But if you need to pass in arguments you’ll have to use @mixin</li>
        </ul>
      </section>

      <!-- SCSS — gulp -->
      <section>
        <h3>What is this gulp thing anyhow?</h3>
        <ul>
          <li>Very flexible JavaScript based pipeline for compilation</li>
          <li><strong>Lots</strong> of pre-prepared plugins to do things like help with vendor prefixes</li>
          <li>Other alternatives include things like Grunt and Compass</li>
        </ul>
      </section>


      <!-- Section — Maintainable CSS -->
      <section class="title-slide banner-3">
        <h2 class="green">Maintainable CSS</h2>
      </section>

      <!-- CSS — maintainable -->
      <section>
        <h3>Maintainable CSS</h3>
        <ul>
          <li>Not a rigid system, just a bunch of best practice suggestions that can be customised</li>
          <li>Likened to building blocks or file document structure</li>
          <li>Why? Well&hellip;</li>
        </ul>
      </section>

      <!-- CSS Architecture — Why -->
      <section>
        <h3>Why structure CSS?</h3>
        <ul>
          <li>Separation and structure makes things easier to find</li>
          <li>Shorter files make it easier to read &amp; modify</li>
          <li>Shared language — another dev can jump straight in</li>
          <li>Flexible and reusable components — speed up building</li>
          <li>Encourages consistency</li>
        </ul>
      </section>

      <!-- CSS — maintainable -->
      <section>
        <h3>Maintainable CSS</h3>
        <p>There are any different theories:
        <ul>
          <li>SMACSS — Scalable and Modular Architecture for CSS</li>
          <li>OOCSS — Object Oriented CSS</li>
          <li>ITCSS — Inverted Triangle CSS</li>
          <li>etc.</li>
        </ul>
      </section>

      <!-- CSS Architecture — Real world example -->
      <section>
        <h3>What might that look like?</h3>
        Example of file structure for an ITCSS project
          <pre><code class="hljs" data-trim contenteditable>
            Settings        - variables, fonts, etc.
            Tools           - mixins, reusable bits
            Generic/vendors - third party scripts, resets
            Elements        - base styling (generally on tags)
            Objects         - design patterns and layouts
            Components      - reusable features and blocks
            Patterns        - components not really reusable/scalable
            Utilities       - overrides and helper classes
        </code></pre>
      </section>

      <!-- CSS Architecture — why -->
      <section>
        <h3>Overarching general principles</h3>
        <ul>
          <li>Separation — group base elements in one place, components in another, etc.</li>
          <li>Consistency — naming and architecture, stick to one throughout a project</li>
          <li>Project based — one size (does not) fit all
            <ul>
              <li>ex.1 ITCSS might be overkill for smaller projects</li>
              <li>ex.2 React projects structure things differently</li>
            </ul>
          </li>
        </ul>
      </section>

      <!-- Section — more CSS -->
      <section class="title-slide banner-5">
        <h2 class="yellow">More CSS!</h2>
      </section>

      <!-- CSS3 animations -->
      <section>
        <h3>CSS3 Animations</h3>
          <h3>🚶 🏃 🚶</h3>
        <p>There are two types: transitions and animations </p>
        <p>Let's quickly look at each</p>
      </section>

      <!-- CSS3 animations - transitions -->
      <section>
        <h3>CSS Transitions</h3>
        <h3>🚶 🏃 🚶</h3>
        <ul>
          <li>Occur when an element changes from one state to another </li>
          <li>Only have two stages: before transition, after transition </li>
        </ul>
      </section>

      <!-- CSS3 animations - animations-->
      <section>
        <h3>CSS Animations</h3>
          <h3>🚶 🏃 🚶</h3>
          <ul>
            <li>Can occur on page load, or on state change</li>
            <li>Animation can have as many stages as needed </li>
         </ul>
      </section>

      <!-- CSS3 animations - example -->
      <section>
        <h3>CSS Animations</h3>
          <h3>🚶 🏃 🚶</h3>
          <p>Give it a go yourself! </p>
          <p>Open scss-example/button.html in your browser </p>
          <p> and _button.scss in Atom</p>
      </section>

      <!-- Flex Overview -->
      <section>
        <h3>Display: flex;</h3>
        <ul>
          <li>Used in place of floats/inline-block for layout structure</li>
          <li>Can align content vertically and horizontally</li>
          <li>Not new but only <a href="https://caniuse.com/#search=flex" target="_blank">recently supported</a></li>
        </ul>
      </section>

      <!-- Flex game -->
      <section>
        <h3>Flex game 🐸</h3>
        <p><a href="https://flexboxfroggy.com/" target="_blank" rel="noopener noreferrer" style="text-decoration:underline;">flexboxfroggy.com</a></p>
      </section>

      <!-- Questions -->
      <section>
        <h3>Questions?</h3>
      </section>

      <!-- Resources -->
      <section>
        <h3>Resources</h3>
        <ul>
          <li style="line-height: 1.3;"><strong style="color:#190F10;">Mozilla web documentation</strong><br>
            <small><a href="https://developer.mozilla.org/en-US/docs/Web" target="_blank" rel="noopener noreferrer" style="text-decoration:underline;">developer.mozilla.org/en-US/docs/Web</a>
            </small><br>
          </li>
          <li style="line-height: 1.3;"><strong style="color:#190F10;">SASS documentation</strong><br>
            <small><a href="https://sass-lang.com/documentation" target="_blank" rel="noopener noreferrer" style="text-decoration:underline;">sass-lang.com/documentation</a>
            </small>
          </li>
          <li style="line-height: 1.3;"><strong style="color:#190F10;">ARIA</strong><br>
            <small>
              <a href="https://developer.mozilla.org/en-US/docs/Web/Accessibility/ARIA" target="_blank" rel="noopener noreferrer" style="text-decoration:underline;">developer.mozilla.org/en-US/docs/Web/Accessibility/ARIA</a>
            </small>
          </li>
          <li style="line-height: 1.3;"><strong style="color:#190F10;">Browser support</strong><br>
            <small><a href="http://caniuse.com/" target="_blank" rel="noopener noreferrer" style="text-decoration:underline;">caniuse.com</a>
            </small>
          </li>
        </ul>
      </section>

      <!-- Slide with Catalyst slogan -->
      <section class="image-slide">
        <h3 style="display: none;">Catalyst — freedom to innovate</h3>
        <img class="cat-slogan-image" src="css/theme/images/freedom-to-innovate.svg" alt="freedom to innovate">
      </section>
    </div>

    <div class="footer">
      <div class="scarf">
        <div class="scarf-orange"></div>
        <div class="scarf-yellow"></div>
        <div class="scarf-blue"></div>
        <div class="scarf-green"></div>
      </div>
      <div class="footer-inner">
        <div class="catalyst-logo-footer"></div>
        <div class="open-source-technologists">open source technologists</div>
      </div>
    </div>
  </div>

  <script src="lib/js/head.min.js"></script>
  <script src="js/reveal.js"></script>
  <script src="js/footer.js"></script>
  <script>

    // Full list of configuration options available here:
    // https://github.com/hakimel/reveal.js#configuration
    Reveal.initialize({
      controls: true,
      progress: true,
      history: true,
      center: true,

      theme: Reveal.getQueryHash().theme, // available themes are in /css/theme
      transition: Reveal.getQueryHash().transition || 'none', // default/cube/page/concave/zoom/linear/fade/none

      // Parallax scrolling
      // parallaxBackgroundImage: 'https://s3.amazonaws.com/hakim-static/reveal-js/reveal-parallax-1.jpg',
      // parallaxBackgroundSize: '2100px 900px',

      // Optional libraries used to extend on reveal.js
      dependencies: [
        { src: 'lib/js/classList.js', condition: function() { return !document.body.classList; } },
        { src: 'plugin/markdown/marked.js', condition: function() { return !!document.querySelector( '[data-markdown]' ); } },
        { src: 'plugin/markdown/markdown.js', condition: function() { return !!document.querySelector( '[data-markdown]' ); } },
        { src: 'plugin/highlight/highlight.js', async: true, callback: function() { hljs.initHighlightingOnLoad(); } },
        { src: 'plugin/zoom-js/zoom.js', async: true, condition: function() { return !!document.body.classList; } },
        { src: 'plugin/notes/notes.js', async: true, condition: function() { return !!document.body.classList; } }
      ]
    });

  </script>

  </body>
</html>
